/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

#pragma once

// author: Nigel Thompson - base code of this class

#include <windows.h>
#include <cpl.h> // control panel definitions
#include <tchar.h>

class ControlPanel
{
public:
	ControlPanel();
	virtual ~ControlPanel();    

	// Event handlers
	virtual LONG OnDblclk(HWND hwndCPl, UINT uAppNum, LONG lData); 
	virtual LONG OnExit();
	virtual LONG OnGetCount();
	virtual LONG OnInit();
	virtual LONG OnInquire(UINT uAppNum, CPLINFO* pInfo) = 0; 
	virtual LONG OnSelect(UINT uAppNum, LONG lData); 
	virtual LONG OnStop(UINT uAppNum, LONG lData); 

	// static member function (callback)
	static LONG APIENTRY CPlApplet(
		HWND hwndCPl, 
		UINT uMsg, 
		LPARAM lParam1, 
		LPARAM lParam2
	);

	static bool Install(LPCTSTR name, LPCTSTR binary_path_name = NULL);
	static bool Uninstall(LPCTSTR name);

	// static data
	static ControlPanel* m_pThis; // HACK: object pointer to use virtual methods
};
