/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

#include "stdafx.h"
#include "DebugConsole.h"

bool DebugConsole::started;
HANDLE DebugConsole::handle;
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::red(FOREGROUND_RED);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::green(FOREGROUND_GREEN);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::blue(FOREGROUND_BLUE);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::cyan(FOREGROUND_GREEN | FOREGROUND_BLUE);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::magenta(FOREGROUND_RED | FOREGROUND_BLUE);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::yellow(FOREGROUND_GREEN | FOREGROUND_RED);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::white(FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::ired(FOREGROUND_INTENSITY | FOREGROUND_RED);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::igreen(FOREGROUND_INTENSITY | FOREGROUND_GREEN);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::iblue(FOREGROUND_INTENSITY | FOREGROUND_BLUE);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::icyan(FOREGROUND_INTENSITY | FOREGROUND_GREEN | FOREGROUND_BLUE);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::imagenta(FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_BLUE);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::iyellow(FOREGROUND_INTENSITY | FOREGROUND_GREEN | FOREGROUND_RED);
const DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::iwhite(FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::atext(FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::aread(igreen);
DebugConsole::ConsoleTextAttribute DebugConsole::ConsoleTextAttribute::awrite(iyellow);

void DebugConsole::Start() const
{
	if (!started && m_output)
	{
		if (AllocConsole())
		{
			int hCrt = _open_osfhandle( 
				reinterpret_cast<long>(GetStdHandle(STD_ERROR_HANDLE)),
				_O_TEXT
			);
			FILE *hf = _fdopen( hCrt, "w" );
			*stderr = *hf;
			//setvbuf( stderr, NULL, _IONBF, 0 ); 
		}
		handle = GetStdHandle(STD_ERROR_HANDLE);
		started = true;
	}
}

DebugConsole::DebugConsole(bool enable)
{
	m_output = enable;
};

void DebugConsole::Output(bool enable)
{
	m_output = enable;
}

const DebugConsole& DebugConsole::operator << (DynamicCurrentTime) const
{
	Start();

	if (m_output)
	{
		using namespace std;
		SYSTEMTIME st;
		GetLocalTime(&st);
		cerr << setfill('0') << setw(2) << st.wHour << ':';
		cerr << setfill('0') << setw(2) << st.wMinute << ':';
		cerr << setfill('0') << setw(2) << st.wSecond << '.';
		cerr << setfill('0') << setw(3) << st.wMilliseconds;
	}
	return *this;
}

const DebugConsole& DebugConsole::operator << (ConsoleTextAttribute cta) const
{
	Start();

	if (m_output)
	{
		SetConsoleTextAttribute(handle, cta.m_attribute);
	}
	return *this;
}

void DebugConsole::Write(const char bytes[], int count) const
{
	if (m_output)
	{
		if (!count)
		{
			*this << ConsoleTextAttribute::ired;
			*this << "(NULL)";
			*this << ConsoleTextAttribute::atext;
			return;
		}
		for (int i = 0; i < count; i++)
		{
			*this << bytes[i];
		}
	}
}
