/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

#pragma once
#include <windows.h>
#include <fcntl.h>
#include <io.h>
#include <iostream>
#include <iomanip>

class DebugConsole
{
private:
	static bool started;
	static HANDLE handle;
	bool m_output;

protected:
	void Start() const;

public:
	class DynamicCurrentTime 
	{
	};
	class ConsoleTextAttribute
	{
	public:
		WORD m_attribute;
		ConsoleTextAttribute(WORD attribute)
		{
			m_attribute = attribute;
		}
		const static ConsoleTextAttribute red;
		const static ConsoleTextAttribute green;
		const static ConsoleTextAttribute blue;
		const static ConsoleTextAttribute cyan;
		const static ConsoleTextAttribute magenta;
		const static ConsoleTextAttribute yellow;
		const static ConsoleTextAttribute white;
		// intensive
		const static ConsoleTextAttribute ired;
		const static ConsoleTextAttribute igreen;
		const static ConsoleTextAttribute iblue;
		const static ConsoleTextAttribute icyan;
		const static ConsoleTextAttribute imagenta;
		const static ConsoleTextAttribute iyellow;
		const static ConsoleTextAttribute iwhite;

		static ConsoleTextAttribute atext; // default attributes for text 
		static ConsoleTextAttribute aread; // default attributes for read from port text 
		static ConsoleTextAttribute awrite; // default attributes for written to port text 
	};

	DebugConsole(bool enable = true);
	void Output(bool enable);
	void Write(const char bytes[], int count) const;
	const DebugConsole& operator << (DynamicCurrentTime) const;
	const DebugConsole& operator << (ConsoleTextAttribute cta) const;

	template<class T> 
		const DebugConsole& operator << (T arg) const
	{
		Start();

		if (m_output)
		{
			std::cerr << arg;
		}
		return *this;
	}
};