/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

#pragma once
#include "sqlite3.h"

class SQLiteDB
{
public:
	class Statment;
	SQLiteDB();
	void Open(const char* dbname);
	void Open(const wchar_t* dbname);
	void Close();
	Statment Prepare(const char* query);
	Statment Prepare(const wchar_t* query);
	int GetLastInsertRowId();
	void ErrorMessage(const char** message);
	void ErrorMessage(const wchar_t** message);
	~SQLiteDB();
private:
	sqlite3* m_db;
private: // do not use
	SQLiteDB(const SQLiteDB& right);
	void operator = (const SQLiteDB& right);

};

class SQLiteDB::Statment
{
public:
	Statment(sqlite3* db, const char* query);
	Statment(sqlite3* db, const wchar_t* query);
	Statment(const Statment& right);
	void operator = (const Statment& right);
	int Step();
	int Columns();
	void Title(int column, const char** title);
	void Title(int column, const wchar_t** title);
	void Text(int column, const char** text);
	void Text(int column, const wchar_t** text);
	int Integer(int column);
	~Statment();
private:
	sqlite3_stmt* m_stmt;
	int* m_refs;
};
