/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

#include "rpctchar.h"

RPC_STATUS RPC_ENTRY RpcStringBindingComposeT(
	char* ObjUuid,
	char* ProtSeq,
	char* NetworkAddr,
	char* EndPoint,
	char* Options,
	char** StringBinding
)
{
	return RpcStringBindingComposeA(
		(unsigned char*) ObjUuid,
		(unsigned char*) ProtSeq,
		(unsigned char*) NetworkAddr,
		(unsigned char*) EndPoint,
		(unsigned char*) Options,
		(unsigned char**) StringBinding
	);
}

RPC_STATUS RPC_ENTRY RpcStringBindingComposeT(
	wchar_t* ObjUuid,
	wchar_t* ProtSeq,
	wchar_t* NetworkAddr,
	wchar_t* EndPoint,
	wchar_t* Options,
	wchar_t** StringBinding
)
{
	return RpcStringBindingComposeW(
		(unsigned short*) ObjUuid,
		(unsigned short*) ProtSeq,
		(unsigned short*) NetworkAddr,
		(unsigned short*) EndPoint,
		(unsigned short*) Options,
		(unsigned short**) StringBinding
	);
}

RPC_STATUS RPC_ENTRY RpcBindingFromStringBindingT(
	char* StringBinding,
	RPC_BINDING_HANDLE* Binding
)
{
	return RpcBindingFromStringBindingA(
		(unsigned char*) StringBinding,
		Binding
	);
}

RPC_STATUS RPC_ENTRY RpcBindingFromStringBindingT(
	wchar_t* StringBinding,
	RPC_BINDING_HANDLE* Binding
)
{
	return RpcBindingFromStringBindingW(
		(unsigned short*) StringBinding,
		Binding
	);
}

RPC_STATUS RPC_ENTRY RpcStringFreeT(
	char** String
)
{
	return RpcStringFreeA(
		(unsigned char**) String
	);
}

RPC_STATUS RPC_ENTRY RpcStringFreeT(
	wchar_t** String
)
{
	return RpcStringFreeW(
		(unsigned short**) String
	);
}




int RpcServerUseProtseqEpT(
	wchar_t* Protseq, 
	unsigned int MaxCalls, 
	wchar_t* Endpoint, 
	void* SecurityDescriptor
)
{
	return RpcServerUseProtseqEpW(
		(unsigned short*)Protseq, 
		MaxCalls, 
		(unsigned short*)Endpoint, 
		SecurityDescriptor
	);
}

int RpcServerUseProtseqEpT(
	char* Protseq, 
	unsigned int MaxCalls, 
	char *Endpoint, 
	void *SecurityDescriptor
)
{
	return RpcServerUseProtseqEpA(
		(unsigned char*)Protseq, 
		MaxCalls, 
		(unsigned char*)Endpoint, 
		SecurityDescriptor
	);
}
