/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

// DialogContact.cpp : implementation file
//

#include "stdafx.h"
#include "smsdemo.h"
#include "DialogContact.h"
#include "Sheet.h"


// DialogContact dialog

IMPLEMENT_DYNAMIC(DialogContact, CDialog)
DialogContact::DialogContact(CWnd* pParent /*=NULL*/)
	: CDialog(DialogContact::IDD, pParent)
	, m_id(0)
	, m_phone(_T(""))
	, m_name(_T(""))
	, m_exist(FALSE)
{
}

DialogContact::~DialogContact()
{
}

void DialogContact::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	// TODO: not only in user interface
	m_phone.Replace(_T('\''), _T('`'));
	m_name.Replace(_T('\''), _T('`'));
	DDX_Text(pDX, IDC_PHONE, m_phone);
	DDX_Text(pDX, IDC_NAME, m_name);
	m_phone.Replace(_T('\''), _T('`'));
	m_name.Replace(_T('\''), _T('`'));
}

void DialogContact::ShowExist()
{
	GetDlgItem(IDC_DELETE)->EnableWindow(m_exist);
	if (m_exist)
		SetWindowText(_T(" /   "));
	else
		SetWindowText(_T("   "));
}

BEGIN_MESSAGE_MAP(DialogContact, CDialog)
	ON_BN_CLICKED(IDC_DELETE, OnBnClickedDelete)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// DialogContact message handlers

// remove
void DialogContact::OnBnClickedDelete()
{
	if (IDOK == MessageBox(_T("  .\n  ?"), 0, MB_OKCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON2))
	{
		OnOK();
 		Sheet* sheet = (Sheet*)GetParent();
		if (sheet->IsKindOf(RUNTIME_CLASS(Sheet)))
		{
			CListCtrl* list = (CListCtrl*)sheet->m_monitor->GetDlgItem(IDC_LIST_CONTACT);
			LVFINDINFO info;
			memset(&info, 0, sizeof(info));
			info.flags = LVFI_PARAM;
			info.lParam = m_id;
			int item = list->FindItem(&info);
			if (item >= 0)
			{
				SQLiteDB* db = CsmsdemoApp::GetDB();
				CString query;
				
				query.Format(_T("DELETE FROM contact WHERE _id = %d"), m_id);
				SQLiteDB::Statment stmt = db->Prepare(query);
				stmt.Step();
				list->DeleteItem(item);
				sheet->m_monitor->RefreshMessages();
			}
		}
	}
}

// add, edit
void DialogContact::OnBnClickedOk()
{
	OnOK();

	Sheet* sheet = (Sheet*)GetParent();
	if (sheet->IsKindOf(RUNTIME_CLASS(Sheet)))
	{
		CListCtrl* list = (CListCtrl*)sheet->m_monitor->GetDlgItem(IDC_LIST_CONTACT);
		LVFINDINFO info;
		memset(&info, 0, sizeof(info));
		info.flags = LVFI_PARAM;
		info.lParam = m_id;
		int item = list->FindItem(&info);
		if (item >= 0)
		{
			SQLiteDB* db = CsmsdemoApp::GetDB();
			CString query;
			bool written = false;
			
			if (m_exist)
			{
				query.Format(_T("UPDATE contact SET _phone='%s', _name='%s' WHERE _id = %d"), 
					m_phone, m_name, m_id);
				SQLiteDB::Statment stmt = db->Prepare(query);
				if (stmt.Step() == SQLITE_DONE)
				{
					written = true;
				}
				else
				{
					const TCHAR* err = 0;
					db->ErrorMessage(&err);
					MessageBox(err, 0, MB_ICONERROR);
				}
			}
			else
			{
				query.Format(_T("INSERT INTO contact (_phone, _name) VALUES('%s', '%s')"), 
					m_phone, m_name);
				SQLiteDB::Statment stmt = db->Prepare(query);
				if (stmt.Step() == SQLITE_DONE)
				{
					m_id = db->GetLastInsertRowId();
					written = true;
				}
				else
				{
					const TCHAR* err = 0;
					db->ErrorMessage(&err);
					MessageBox(err, 0, MB_ICONERROR);
				}
			}

			if (written)
			{
				list->SetItemData(item, m_id);
				list->SetItemText(item, PageMonitor::CNT_PHONE, m_phone);
				list->SetItemText(item, PageMonitor::CNT_NAME, m_name);

				if (!m_exist)
					sheet->m_monitor->AddItemNew();	
				
				sheet->m_monitor->RefreshMessages();
			}
		}
	}
}

void DialogContact::OnBnClickedCancel()
{
	OnCancel();
}
