/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

#pragma once
#include "afxcmn.h"
#include "DialogContact.h"


class OwnerListCtrl : public CListCtrl
{
	DECLARE_DYNAMIC(OwnerListCtrl)
	DECLARE_MESSAGE_MAP()
protected:
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

public:
	OwnerListCtrl();
	virtual ~OwnerListCtrl();
};

// PageMonitor dialog

class PageMonitor : public CPropertyPage
{
	OwnerListCtrl m_messages;
	CListCtrl m_contacts;
	int m_class;
	DialogContact* m_edit_contact;

	CRITICAL_SECTION m_sect;

// Dialog Data
	enum { IDD = IDD_PAGE_MONITOR };

	DECLARE_DYNAMIC(PageMonitor)
	DECLARE_MESSAGE_MAP()

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg void OnLvnItemActivateMessage(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg void OnHdnItemclickContact(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemActivateContact(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeText();
	afx_msg void OnBnClickedSend();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();

	static DWORD WINAPI ReceiverThread(LPVOID lpThis);
	void Receiver();
	void ProcessSMS(SMS sms);
	void InsertMessageById(int id);


public:
	PageMonitor();
	virtual ~PageMonitor();

	enum {
		SMS_HIDDEN, 
		SMS_STATE, 
		SMS_PHONE, 
		SMS_DATETIME, 
		SMS_NAME, 
		SMS_TEXT,
		SMS_END,
	};

	enum {
		CNT_SMS, 
		CNT_PHONE, 
		CNT_NAME, 
		CNT_END,
	};

	void RefreshMessages();
	void RefreshContacts();
	void AddItemNew();
	afx_msg void OnBnClickedButtonDelete();
};
