/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

// PageSettings.cpp : implementation file
//

#include "stdafx.h"
#include "smsdemo.h"
#include "PageSettings.h"
#include ".\pagesettings.h"

// PageSettings dialog

IMPLEMENT_DYNAMIC(PageSettings, CPropertyPage)
PageSettings::PageSettings()
	: CPropertyPage(PageSettings::IDD)
{
}

PageSettings::~PageSettings()
{
}

void PageSettings::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(PageSettings, CPropertyPage)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BIND, OnBnClickedBind)
END_MESSAGE_MAP()


// PageSettings message handlers

BOOL PageSettings::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	CString protocol_sequence = theApp.GetProfileString(_T("Settings"), _T("protocol_sequence"));
	SetDlgItemText(IDC_COMBO1, protocol_sequence);
	CString endpoint = theApp.GetProfileString(_T("Settings"), _T("endpoint"));
	SetDlgItemText(IDC_COMBO2, endpoint);
	CString network_address = theApp.GetProfileString(_T("Settings"), _T("network_address"));
	SetDlgItemText(IDC_COMBO3, network_address);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void PageSettings::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
}

void PageSettings::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
}

void PageSettings::OnBnClickedBind()
{
	TCHAR protocol_sequence[1024] = {0};
	GetDlgItemText(IDC_COMBO1, protocol_sequence, 1024);
	theApp.WriteProfileString(_T("Settings"), _T("protocol_sequence"), protocol_sequence);

	TCHAR endpoint[1024] = {0};
	GetDlgItemText(IDC_COMBO2, endpoint, 1024);
	theApp.WriteProfileString(_T("Settings"), _T("endpoint"), endpoint);

	TCHAR network_address[1024] = {0};
	GetDlgItemText(IDC_COMBO3, network_address, 1024);
	theApp.WriteProfileString(_T("Settings"), _T("network_address"), network_address);

	CsmsdemoApp::Bind();
}
