/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

// Sheet.cpp : implementation file
//

#include "stdafx.h"
#include "smsdemo.h"
#include "Sheet.h"


// Sheet
IMPLEMENT_DYNAMIC(Sheet, CPropertySheet)


Sheet::Sheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_monitor = new PageMonitor();
	AddPage(m_monitor);
	m_settings = new PageSettings();
	AddPage(m_settings);
}

Sheet::~Sheet()
{
	delete m_settings;
	delete m_monitor;
}

// Sheet message handlers
BOOL Sheet::OnInitDialog()
{
	CPropertySheet::OnInitDialog();

	ModifyStyle(0, WS_MINIMIZEBOX);
	if (GetDlgItem(IDOK)) GetDlgItem(IDOK)->DestroyWindow();
	if (GetDlgItem(IDCANCEL)) GetDlgItem(IDCANCEL)->DestroyWindow();
	if (GetDlgItem(ID_APPLY_NOW)) GetDlgItem(ID_APPLY_NOW)->DestroyWindow();
	if (GetDlgItem(IDHELP)) GetDlgItem(IDHELP)->DestroyWindow();
	return TRUE;
}


BEGIN_MESSAGE_MAP(Sheet, CPropertySheet)
END_MESSAGE_MAP()


// Sheet message handlers
