/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

#pragma once
#include "cpplib\SimpleService.h"
#include "cpplib\GSM\gsm.h"

class SMSService 
	: public SimpleService
{
private:
	// parameters
	static const int MAX_PARAMLEN = 1024;
	static TCHAR m_ProtocolSequence[MAX_PARAMLEN];
	static TCHAR m_Endpoint[MAX_PARAMLEN];
	static DWORD m_MaxCalls;
	static DWORD m_MaxSize;
	static TCHAR m_ComPort[MAX_PARAMLEN];
	static TCHAR m_PIN[MAX_PARAMLEN];
	static DWORD m_DeleteNewSMS; // 0 - no, else - yes
	static DWORD m_DeleteAtStartup; // how many
	static DWORD m_KeepAliveMilliseconds;

	static GSM m_gsm;

	static bool LoadParameter(LPCTSTR name, LPTSTR value);
	static bool LoadParameter(LPCTSTR name, DWORD& value);
	static void InitGSM();
	static bool InitRPC();

	static void FormatErrorMessage(DWORD error, LPTSTR message, DWORD size);

protected:
	virtual void OnStart(DWORD argc, LPTSTR *argv);
	virtual void OnStop();
	virtual void OnShutdown();

public:
	static bool InitParameters();
	static void Post(SMS sms);
	static int Send(SMS sms);
	static int Receive(SMS *sms, int timeout);
};
