/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

#include "SMSService.h"
#include "cpplib\ControlPanel.h"

int _tmain(DWORD argc, LPTSTR *argv)
{
	//PDU pdu;
	//SMS sms;
	//memset(&sms, 0, sizeof(sms));
	//wsprintf(sms.Data, L"This is a PDU message");
	//sprintf((char*)sms.Phone, "359881234567");
	//sprintf((char*)sms.SCA, "35988000301");
	//pdu.Decompose(sms);
	//printf(pdu.Unit(0));
	//return 0;

	if (argc > 1)
	{
		if (!_tcscmp(argv[1], _T("-i")))  // -i install
		{
			if (SimpleService::IsInstalled(_T("smssvc")))
			{
				fprintf(stderr, "error installing smssvc\n");
				fprintf(stderr, "smssvc is already installed\n");
			}
			else if (SimpleService::Install(_T("smssvc"), _T("Short Messages Service")))
			{
				SMSService::SetName(_T("smssvc"));
				SMSService::InitParameters();
				fprintf(stderr, "smssvc successfully installed\n");
				if (argc > 2)
				{
					if (ControlPanel::Install(_T("smssvc"), argv[2]))
						fprintf(stderr, "smssvc control panel successfully installed\n");
					else
						fprintf(stderr, "error installing smssvc control panel\n");
				}
			}
			else
			{
				fprintf(stderr, "error installing smssvc\n");
			}
		}
		else if (!_tcscmp(argv[1], _T("-d")))  // -d deinstall
		{
			if (SimpleService::Uninstall(_T("smssvc")))
				fprintf(stderr, "smssvc successfully deinstalled\n");
			else
				fprintf(stderr, "error deinstalling smssvc\n");
			if (ControlPanel::Uninstall(_T("smssvc")))
				fprintf(stderr, "smssvc control panel successfully deinstalled\n");
			else
				fprintf(stderr, "error deinstalling smssvc control panel\n");
		}
		else
		{
			fprintf(stderr, "usage: smssvc -i full-path-and-name-of-smssvc.cpl\n");
			fprintf(stderr, "or     smssvc -d\n");
			fprintf(stderr, "or     smssvc\n");
		}
	}
	else
	{
		SMSService svc;
		svc.SetName(_T("smssvc")); // for console testing
		svc.Run(argc, argv);
	}
	return 0;
}

