/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

// PageGSM.cpp : implementation file
//

#include "stdafx.h"
#include "smssvc.h"
#include "PageGSM.h"
#include "Sheet.h"
#include "cpplib\SimpleService.h"

// PageGSM dialog

IMPLEMENT_DYNAMIC(PageGSM, CPropertyPage)
PageGSM::PageGSM()
	: CPropertyPage(PageGSM::IDD)
{
}

PageGSM::~PageGSM()
{
}

void PageGSM::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BOOL PageGSM::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	TCHAR text[2048];
	DWORD length;
	DWORD value;
	CComboBox* combo;
	int index;

	length = 2048;
	SimpleService::GetParameter(_T("COM_Port"), text, &length);
	combo = (CComboBox*)GetDlgItem(IDC_COMBO_PORT);
	index = combo->FindString(-1, text);
	if (index != CB_ERR)
		combo->SetCurSel(index);
	else
	{
		combo->InsertString(0, text);
		combo->SetCurSel(0);
	}

	length = 2048;
	SimpleService::GetParameter(_T("GSM_PINCode"), text, &length);
	combo = (CComboBox*)GetDlgItem(IDC_COMBO_PIN);
	index = combo->FindString(-1, text);
	if (index != CB_ERR)
		combo->SetCurSel(index);
	else
	{
		combo->InsertString(0, text);
		combo->SetCurSel(0);
	}

	SimpleService::GetParameter(_T("GSM_DeleteNewSMS"), value);
	CButton* check = (CButton*)GetDlgItem(IDC_DELETENEW);
	check->SetCheck(value);
		
	length = 2048;
	SimpleService::GetParameter(_T("GSM_DeleteAtStartup"), value);
	combo = (CComboBox*)GetDlgItem(IDC_COMBO_DEL);
	_stprintf(text, _T("%d"), value);
	index = combo->FindString(-1, text);
	if (index != CB_ERR)
		combo->SetCurSel(index);
	else
	{
		combo->InsertString(0, text);
		combo->SetCurSel(0);
	}

	length = 2048;
	SimpleService::GetParameter(_T("GSM_KeepAliveMilliseconds"), value);
	combo = (CComboBox*)GetDlgItem(IDC_COMBO_KEEPALIVE);
	_stprintf(text, _T("%d"), value);
	index = combo->FindString(-1, text);
	if (index != CB_ERR)
		combo->SetCurSel(index);
	else
	{
		combo->InsertString(0, text);
		combo->SetCurSel(0);
	}

	return TRUE;
}
void PageGSM::OnOK()
{
	CString text;
	DWORD value = 0;
	//BOOL trans;

	GetDlgItemText(IDC_COMBO_PORT, text);
	SimpleService::SetParameter(_T("COM_Port"), text);

	GetDlgItemText(IDC_COMBO_PIN, text);
	SimpleService::SetParameter(_T("GSM_PINCode"), text);

	CButton* check = (CButton*)GetDlgItem(IDC_DELETENEW);
	value = check->GetCheck();
	SimpleService::SetParameter(_T("GSM_DeleteNewSMS"), value);

	value = GetDlgItemInt(IDC_COMBO_DEL);
	SimpleService::SetParameter(_T("GSM_DeleteAtStartup"), value);

	value = GetDlgItemInt(IDC_COMBO_KEEPALIVE);
	SimpleService::SetParameter(_T("GSM_KeepAliveMilliseconds"), value);
}

BEGIN_MESSAGE_MAP(PageGSM, CPropertyPage)
	ON_CBN_EDITCHANGE(IDC_COMBO_PORT, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_PORT, OnChange)
	ON_CBN_EDITCHANGE(IDC_COMBO_PIN, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_PIN, OnChange)
	ON_CBN_EDITCHANGE(IDC_COMBO_DEL, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_DEL, OnChange)
	ON_CBN_SELCHANGE(IDC_COMBO_KEEPALIVE, OnChange)
	ON_CBN_EDITCHANGE(IDC_COMBO_KEEPALIVE, OnChange)
	ON_BN_CLICKED(IDC_DELETENEW, OnChange)
END_MESSAGE_MAP()


// PageGSM message handlers

void PageGSM::OnChange()
{
	SetModified(TRUE);
}
