/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

// PageRPC.cpp : implementation file
//

#include "stdafx.h"
#include "smssvc.h"
#include "PageRPC.h"
#include "Sheet.h"
#include "cpplib\SimpleService.h"

// PageRPC dialog

IMPLEMENT_DYNAMIC(PageRPC, CPropertyPage)
PageRPC::PageRPC()
	: CPropertyPage(PageRPC::IDD)
{
}

PageRPC::~PageRPC()
{
}

void PageRPC::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BOOL PageRPC::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	TCHAR text[2048];
	DWORD length;
	DWORD value;
	CComboBox* combo;
	int index;

	length = 2048;
	SimpleService::GetParameter(_T("RPC_ProtocolSequence"), text, &length);
	combo = (CComboBox*)GetDlgItem(IDC_COMBO1);
	index = combo->FindString(-1, text);
	if (index != CB_ERR)
		combo->SetCurSel(index);
	else
	{
		combo->InsertString(0, text);
		combo->SetCurSel(0);
	}

	length = 2048;
	SimpleService::GetParameter(_T("RPC_Endpoint"), text, &length);
	combo = (CComboBox*)GetDlgItem(IDC_COMBO2);
	index = combo->FindString(-1, text);
	if (index != CB_ERR)
		combo->SetCurSel(index);
	else
	{
		combo->InsertString(0, text);
		combo->SetCurSel(0);
	}

	SimpleService::GetParameter(_T("RPC_MaxCalls"), value);
	_stprintf(text, _T("%d"), value);
	combo = (CComboBox*)GetDlgItem(IDC_COMBO3);
	index = combo->FindString(-1, text);
	if (index != CB_ERR)
		combo->SetCurSel(index);
	else
	{
		combo->InsertString(0, text);
		combo->SetCurSel(0);
	}
	
	SimpleService::GetParameter(_T("RPC_MaxSize"), value);
	_stprintf(text, _T("%d"), value);
	combo = (CComboBox*)GetDlgItem(IDC_COMBO4);
	index = combo->FindString(-1, text);
	if (index != CB_ERR)
		combo->SetCurSel(index);
	else
	{
		combo->InsertString(0, text);
		combo->SetCurSel(0);
	}
		
	return TRUE;
}


void PageRPC::OnOK()
{
	CString text;
	DWORD value = 0;
	BOOL trans;

	GetDlgItemText(IDC_COMBO1, text);
	SimpleService::SetParameter(_T("RPC_ProtocolSequence"), text);

	GetDlgItemText(IDC_COMBO2, text);
	SimpleService::SetParameter(_T("RPC_Endpoint"), text);

	value = GetDlgItemInt(IDC_COMBO3, &trans);
	if (trans)
		SimpleService::SetParameter(_T("RPC_MaxCalls"), value);

	value = GetDlgItemInt(IDC_COMBO4, &trans);
	if (trans)
		SimpleService::SetParameter(_T("RPC_MaxSize"), value);
}

BEGIN_MESSAGE_MAP(PageRPC, CPropertyPage)
	ON_CBN_EDITCHANGE(IDC_COMBO1, OnCbnEditchangeCombo)
	ON_CBN_EDITCHANGE(IDC_COMBO2, OnCbnEditchangeCombo)
	ON_CBN_EDITCHANGE(IDC_COMBO3, OnCbnEditchangeCombo)
	ON_CBN_EDITCHANGE(IDC_COMBO4, OnCbnEditchangeCombo)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeCombo)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnCbnSelchangeCombo)
	ON_CBN_SELCHANGE(IDC_COMBO3, OnCbnSelchangeCombo)
	ON_CBN_SELCHANGE(IDC_COMBO4, OnCbnSelchangeCombo)
END_MESSAGE_MAP()


// PageRPC message handlers

void PageRPC::OnCbnEditchangeCombo()
{
	SetModified(TRUE);
}

void PageRPC::OnCbnSelchangeCombo()
{
	SetModified(TRUE);
}
