/**********************************************
 * Application: SMS service and demo          *
 * Author: Vladislav Iliev                    *
 * e-mail: vladislav10@abv.bg                 *
 * Year: 2007                                 *
 * FN: M-21557                                *
 * University of Sofia "St. Kliment Ohridski" *
 * Faculty of Mathematics and Informatics     *
 **********************************************/

// PageStatus.cpp : implementation file
//

#include "stdafx.h"
#include "smssvc.h"
#include "PageStatus.h"
#include ".\pagestatus.h"

#include "cpplib\SimpleService.h"


// PageStatus dialog

IMPLEMENT_DYNAMIC(PageStatus, CPropertyPage)
PageStatus::PageStatus()
	: CPropertyPage(PageStatus::IDD)
{
}

PageStatus::~PageStatus()
{
}

void PageStatus::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BOOL PageStatus::OnSetActive()
{
	SetTimer(1, 1000, 0);
	return TRUE;
}

BOOL PageStatus::OnKillActive()
{
	KillTimer(1);
	return TRUE;
}

BEGIN_MESSAGE_MAP(PageStatus, CPropertyPage)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START, OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, OnBnClickedStop)
	ON_BN_CLICKED(IDC_RESTART, OnBnClickedRestart)
END_MESSAGE_MAP()


// PageStatus message handlers

void PageStatus::OnTimer(UINT_PTR nIDEvent)
{
	ShowStatus();
}


void PageStatus::OnBnClickedStart()
{
	SimpleService::Start(MYSERVICENAME);
	ShowStatus();
}

void PageStatus::OnBnClickedStop()
{
 	SimpleService::Stop(MYSERVICENAME);
	ShowStatus();
}

void PageStatus::OnBnClickedRestart()
{
	CWaitCursor wc;
 	SimpleService::Stop(MYSERVICENAME);
	for (int i = 0; i < 5; i++)
	{
		// sleep 1 sec
		Sleep(1000);
		SERVICE_STATUS status;
		SimpleService::Query(MYSERVICENAME, &status);
		if (status.dwCurrentState == SERVICE_STOPPED)
			break;
	}
	SimpleService::Start(MYSERVICENAME);
	ShowStatus();
}

void PageStatus::ShowStatus()
{
	SERVICE_STATUS status;
	SimpleService::Query(MYSERVICENAME, &status);

	// translate in words what we got
	TCHAR buf[1024];

	switch (status.dwCurrentState) {
		case SERVICE_STOPPED:
			_tcscpy(buf, _T("Stopped"));
			EnableStart(true);
			break;
		case SERVICE_START_PENDING:
			_tcscpy(buf, _T("Start pending"));
			break;
		case SERVICE_STOP_PENDING:
			_tcscpy(buf, _T("Stop pending"));
			break;
		case SERVICE_RUNNING:
			EnableStart(false);
			_tcscpy(buf, _T("Running"));
			break;
		case SERVICE_CONTINUE_PENDING:
			_tcscpy(buf, _T("Continue pending"));
			break;
		case SERVICE_PAUSE_PENDING:
			_tcscpy(buf, _T("Pause pending"));
			break;
		case SERVICE_PAUSED:
			_tcscpy(buf, _T("Paused"));
			break;
		default:
			_tcscpy(buf, _T("<Unknown>"));
			break;
	}
	SetDlgItemText(IDC_STATUS, buf);
}

void PageStatus::EnableStart(bool enable)
{
	GetDlgItem(IDC_START)->EnableWindow(enable);
	GetDlgItem(IDC_STOP)->EnableWindow(!enable);
	GetDlgItem(IDC_RESTART)->EnableWindow(!enable);
}
